
#include <owl\owlpch.h>
#pragma hdrstop

#include <containr.h>
#include <imagelst.h>

TContainer::TContainer(   TWindow* parent,
                           int id,
                           const char far* title,
                           int x, int y, int w, int h,
                           DWORD dwListStyles, TModule* module )

   :TControl(parent, id, title, x, y, w, h, module)
{
   InitCommonControls(); // ?? move to app init

   Attr.Style |= dwListStyles;
}

// ---------------------------------------------------------------------------

char* TContainer::GetClassName()
{
   return WC_LISTVIEW;
}

// ---------------------------------------------------------------------------

void TContainer::ChangeView( DWORD dwnewStyle)
{
   // LVS_ICON or LVS_SMALLICON or LVS_LIST or LVS_REPORT

   DWORD dwStyle = GetWindowLong( GWL_STYLE);

   if ((dwStyle & LVS_TYPEMASK) != dwnewStyle)
      SetWindowLong(GWL_STYLE, (dwStyle & ~LVS_TYPEMASK) | dwnewStyle);
}

// ---------------------------------------------------------------------------

void TContainer::ShowSelectionAlways( BOOL ShowSelection)
{
   DWORD dwStyle = GetWindowLong( GWL_STYLE);

   if  ( (!ShowSelection) && (dwStyle & LVS_SHOWSELALWAYS))
      SetWindowLong(GWL_STYLE,dwStyle & ~LVS_SHOWSELALWAYS);
   else
      if  ( (ShowSelection) && !(dwStyle & LVS_SHOWSELALWAYS))
         SetWindowLong(GWL_STYLE,dwStyle | LVS_SHOWSELALWAYS);
}

// ---------------------------------------------------------------------------

HIMAGELIST TContainer::SetImageList( HIMAGELIST himl, int iListStyle)
{
   return ListView_SetImageList( HWindow, himl, iListStyle);
}

// ---------------------------------------------------------------------------

HIMAGELIST TContainer::GetImageList(int iImageList)
{
   return ListView_GetImageList( HWindow, iImageList);
}

// ---------------------------------------------------------------------------

BOOL TContainer::DeleteAllItems()
{
   return ListView_DeleteAllItems(HWindow);
}

// ---------------------------------------------------------------------------

BOOL TContainer::DeleteContainerItem(int iItem)
{
   return ListView_DeleteItem( HWindow, iItem);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetItem(LV_ITEM* pItem)
{
   return ListView_GetItem( HWindow, pItem);
}

// ---------------------------------------------------------------------------

int  TContainer::GetItemCount()
{
   return ListView_GetItemCount( HWindow);
}

// ---------------------------------------------------------------------------

int  TContainer::GetSelectedCount()
{
   return ListView_GetSelectedCount( HWindow);
}

// ---------------------------------------------------------------------------

DWORD TContainer::GerItemSpaceing(BOOL bSmall)
{
   return ListView_GetItemSpacing( HWindow, bSmall);
}

// ---------------------------------------------------------------------------

UINT TContainer::GetItemState(int iItem, UINT mask)
{
   return ListView_GetItemState( HWindow, iItem, mask);
}

// ---------------------------------------------------------------------------

void TContainer::GetItemText(int iItem, int iSubItem, LPSTR pszText, int MaxTextLen)
{
   ListView_GetItemText( HWindow, iItem, iSubItem, pszText, MaxTextLen);
}

// ---------------------------------------------------------------------------

int  TContainer::InsertItem(const LV_ITEM* pItem)
{
   return ListView_InsertItem( HWindow, pItem);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SetItem(const LV_ITEM* pItem)
{
   return ListView_SetItem( HWindow, pItem);
}

// ---------------------------------------------------------------------------

void TContainer::SetItemCount(int iItemCount)
{
   ListView_SetItemCount( HWindow, iItemCount);
}

// ---------------------------------------------------------------------------

void TContainer::SetItemState(int iItem, UINT state, UINT mask)
{
   ListView_SetItemState( HWindow, iItem, state, mask);
}

// ---------------------------------------------------------------------------

void TContainer::SetItemText(int iItem, int iSubItem, LPCSTR pszText)
{
   ListView_SetItemText( HWindow, iItem, iSubItem, (LPSTR)pszText);
}

// ---------------------------------------------------------------------------

BOOL TContainer::RedrawItems(int iItemFirst, int iItemLast)
{
   return ListView_RedrawItems( HWindow, iItemFirst, iItemLast);
}

// ---------------------------------------------------------------------------

UINT TContainer::GetCallbackMask()
{
   return ListView_GetCallbackMask( HWindow);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SetCallbackMask(int iNewMask)
{
   return ListView_SetCallbackMask( HWindow, iNewMask);
}

// ---------------------------------------------------------------------------

BOOL TContainer::Update(int iItem)
{
   return ListView_Update( HWindow, iItem);
}

// ---------------------------------------------------------------------------

BOOL TContainer::DeleteColumn( int iColumn)
{
   return ListView_DeleteColumn( HWindow, iColumn);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetColumn( int iColumn, LV_COLUMN* pColumn)
{
   return ListView_GetColumn( HWindow, iColumn, pColumn);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SetColumn( int iColumn, LV_COLUMN* pColumn)
{
   return ListView_SetColumn( HWindow, iColumn, pColumn);
}

// ---------------------------------------------------------------------------

int TContainer::InsertColumn( int iColumn, LV_COLUMN* pColumn)
{
   return ListView_InsertColumn( HWindow, iColumn, pColumn);
}

// ---------------------------------------------------------------------------

int TContainer::GetColumnWidth( int iColumn)
{
   return ListView_GetColumnWidth( HWindow, iColumn);
}

// ---------------------------------------------------------------------------

int TContainer::GetStringWidth( LPCSTR psz)
{
   return ListView_GetStringWidth( HWindow, psz);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SetColumnWidth( int iColumn, int iColumnWidth)
{
   return ListView_SetColumnWidth( HWindow, iColumn, iColumnWidth);
}

// ---------------------------------------------------------------------------

BOOL TContainer::ArrangeItems( UINT uiAlignment)
{
   return ListView_Arrange( HWindow, uiAlignment);
}

// ---------------------------------------------------------------------------

int TContainer::FindItem( int iStartIndex, LV_FINDINFO* pFindInfo)
{
   return ListView_FindItem( HWindow, iStartIndex, pFindInfo);
}

// ---------------------------------------------------------------------------

int TContainer::GetNextItem( int iStartIndex, UINT flags)
{
   return ListView_FindItem( HWindow, iStartIndex, flags);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SortItems( PFNLVCOMPARE pfnCompare, LPARAM lParamSort)
{
   return ListView_SortItems( HWindow, pfnCompare, lParamSort);
}

// ---------------------------------------------------------------------------

BOOL TContainer::EnsureVisible( int iItem, BOOL bPartialOk)
{
   return ListView_EnsureVisible( HWindow, iItem, bPartialOk);
}

// ---------------------------------------------------------------------------

int TContainer::GetCountPerPage()
{
   return ListView_GetCountPerPage(HWindow);
}

// ---------------------------------------------------------------------------

int TContainer::GetTopIndex()
{
   return ListView_GetTopIndex(HWindow);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetItemPosition( int iItem, POINT* pt)
{
   return ListView_GetItemPosition( HWindow, iItem, pt);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetItemRect( int iItem, RECT* rect, int code)
{
   return ListView_GetItemRect( HWindow, iItem, rect, code);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetOrigin( LPPOINT lpPoint)
{
   return ListView_GetOrigin( HWindow, lpPoint);
}

// ---------------------------------------------------------------------------

BOOL TContainer::GetViewRect( RECT* pRect)
{
   return ListView_GetViewRect( HWindow, pRect);
}

// ---------------------------------------------------------------------------

int TContainer::HitTest( LV_HITTESTINFO* phtti)
{
   return ListView_HitTest( HWindow, phtti);
}

// ---------------------------------------------------------------------------

BOOL TContainer::Scroll( int dx, int dy)
{
   return ListView_Scroll( HWindow, dx, dy);
}

// ---------------------------------------------------------------------------

BOOL TContainer::SetItemPosition( int iItemIndex, int x, int y)
{
   return ListView_SetItemPosition( HWindow, iItemIndex, x, y);
}

// ---------------------------------------------------------------------------


