/*  Project listview
    Chinchilla Soft Ltd
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    listview.exe Application
    FILE:         imagelist.h
    AUTHOR:       Johannes Plachy


    OVERVIEW
    ========
    Class definition for of TImageList.

    TImageList is a wrapperclass for the Windows 95 Imagelist.

*/

#ifndef IMAGELST_HXX
#define IMAGELST_HXX


#include <windows.h>
#include <commctrl.h>   // includes the common control header

// ---------------------------------------------------------------------------

class TImageList
{
   HIMAGELIST hImageList;
   BOOL IsOwner;

public :
   TImageList();
   TImageList( int cx, int cy, UINT flags, int cInitial, int cGrow, BOOL Owner = TRUE);
   TImageList( HIMAGELIST hImageList, BOOL Owner = FALSE);
   ~TImageList();

   inline int Add( HBITMAP hImage, HBITMAP hMask = 0 );
   inline int AddIcon( HICON hImage);
   inline BOOL Remove( int iItem);
   inline BOOL RemoveAll();
   inline BOOL Replace( int iItem, HBITMAP hImage, HBITMAP hMask = 0 );
   inline BOOL ReplaceIcon( int iItem, HICON hImage);
   inline BOOL Draw( int iDraw, HDC hdcDst, int x, int y, UINT fStyle);
   inline BOOL DrawEx( int iDraw, HDC hdcDst,int x, int y, int cx, int cy,
                        COLORREF rgbBk, COLORREF rgbFg, UINT fStyle);

   inline HICON ExtractIcon( int hItem);
   inline HICON GetIcon( int hItem, UINT style);

   inline BOOL SetIconSize( int cx, int cy);

   inline int GetImageCount();

   inline operator HIMAGELIST();
};

// ---------------------------------------------------------------------------

#endif // IMAGELST_HXX
