/*  Project listview
    Chinchilla Soft Ltd
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    listview.exe Application
    FILE:         lstvwapp.cpp
    AUTHOR:       Johannes Plachy


    OVERVIEW
    ========
    Source file for implementation of listviewApp (TApplication).      
*/


#include <owl\owlpch.h>
#pragma hdrstop


#include "lstvwapp.h"
#include "lstvwwnd.h"                        // Definition of client class.       
#include "lstvwabd.h"                        // Definition of about dialog.       


//{{listviewApp Implementation}}


DEFINE_RESPONSE_TABLE1(listviewApp, TApplication)
//{{listviewAppRSP_TBL_BEGIN}}
    EV_COMMAND(CM_FILENEW, CmFileNew),
    EV_COMMAND(CM_FILEOPEN, CmFileOpen),
    EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{listviewAppRSP_TBL_END}}
END_RESPONSE_TABLE;


listviewApp::listviewApp () : TApplication("listview")
{

    FileData.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
    FileData.SetFilter("All Files (*.*)|*.*|");

    // INSERT>> Your constructor code here.
}


listviewApp::~listviewApp ()
{
    // INSERT>> Your destructor code here.
}


void listviewApp::InitMainWindow ()
{
    if (nCmdShow != SW_HIDE)
        nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

    TListViewWindow *frame = new TListViewWindow(0, GetName(), 0, false);

    frame->SetIcon(this, IDI_SDIAPPLICATION);

    frame->AssignMenu(SDI_MENU);

    frame->Attr.AccelTable = SDI_MENU;


    SetMainWindow(frame);

    frame->SetMenuDescr(TMenuDescr(SDI_MENU));

    EnableCtl3d(true);
}


void listviewApp::CmFileNew ()
{
}


void listviewApp::CmFileOpen ()
{
}


void listviewApp::OpenFile (const char *)
{
}

// Menu Help About listview.exe command
void listviewApp::CmHelpAbout ()
{
    listviewAboutDlg(MainWindow).Execute();
}
int OwlMain (int , char* [])
{
    try {
        listviewApp    app;
        return app.Run();
    }
    catch (xmsg& x) {
        ::MessageBox(0, x.why().c_str(), "Exception", MB_OK);
    }

    return -1;
}


//    listviewAboutDlg   *xlistviewAboutDlg = new listviewAboutDlg(TWindow* parent, TResId resId = IDD_ABOUT, TModule* module = 0);


