#if !defined(__lstvwwnd_h)              // Sentry, use file only if it's not already included.
#define __lstvwwnd_h

/*  Project listview
    Chinchilla Soft Ltd
    Copyright  1995. All Rights Reserved.

    SUBSYSTEM:    listview.exe Application
    FILE:         lstvwwnd.h
    AUTHOR:       Johannes Plachy


    OVERVIEW
    ========
    Class definition for listviewWindow (TWindow).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "lstvwapp.rh"            // Definition of all resources.

#define TREEVIEW_EXMAPLE  // undefine this line for a lisview sample

#include <containr.h>
#include <treeview.h>
#include <imagelst.h>

//{{TWindow = listviewWindow}}
class TListViewWindow : public TDecoratedFrame
{
TImageList* pIconImageList;
TImageList* pBmpImageList;

#ifdef TREEVIEW_EXMAPLE
TTreeView* pView;
#else
TContainer* pView;
#endif

public:

   TListViewWindow(TWindow* Parent, const char far* title = 0,
                  TWindow* clientWnd = 0,
                  bool shrinkToClient = TRUE,
                  TModule* module = 0);

    TListViewWindow (TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~TListViewWindow ();

protected:
    void SetupWindow();

    void ChangeView( WPARAM Command);

    HTREEITEM AddTreeItem( HTREEITEM ItemToInsertAfter, HTREEITEM ParentItem, LPSTR text, int iImage );

    LRESULT ContainerNotification( WPARAM wParam, LPARAM lParam);

DECLARE_RESPONSE_TABLE(TListViewWindow);

};    //{{TListViewWindow}}


#endif                                      // __lstvwwnd_h sentry.
