
#include <owl\owlpch.h>
#pragma hdrstop

#include <treeview.h>
#include <imagelst.h>

TTreeView::TTreeView(   TWindow* parent,
                           int id,
                           const char far* title,
                           int x, int y, int w, int h,
                           DWORD dwListStyles, TModule* module )

   :TControl(parent, id, title, x, y, w, h, module)
{
   InitCommonControls(); //

   Attr.Style |= dwListStyles;
}

// ---------------------------------------------------------------------------

char* TTreeView::GetClassName()
{
   return WC_TREEVIEW;
}

// ---------------------------------------------------------------------------

HWND TTreeView::EditLabel( HTREEITEM hitem)
{
   return TreeView_EditLabel( HWindow, hitem);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::EndEditLabel( BOOL fCancel)
{
   return TreeView_EndEditLabelNow( HWindow, fCancel);
}

// ---------------------------------------------------------------------------

HWND TTreeView::GetEditControl()
{
   return TreeView_GetEditControl(HWindow);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::GetItem( TV_ITEM* pItem)
{
   return TreeView_GetItem( HWindow, pItem);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::SetItem( const TV_ITEM* pItem)
{
   return TreeView_SetItem( HWindow, pItem);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::SelectItem( WPARAM flags, HTREEITEM hItem)
{
   return TreeView_Select( HWindow, hItem, flags);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::SelectDropTarget( HTREEITEM hItem)
{
   return SelectItem( TVGN_DROPHILITE, hItem);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::SelectFirstVisible( HTREEITEM hItem)
{
   return SelectItem( TVGN_FIRSTVISIBLE, hItem);
}

// ---------------------------------------------------------------------------

HIMAGELIST TTreeView::GetImageList( WPARAM wImage)
{
   return TreeView_GetImageList( HWindow, wImage);
}

// ---------------------------------------------------------------------------

HIMAGELIST TTreeView::SetImageList( HIMAGELIST hIml, WPARAM wImage)
{
   return TreeView_SetImageList( HWindow, hIml, wImage);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::InsertItem( LPTV_INSERTSTRUCT lpis)
{
   return TreeView_InsertItem( HWindow, lpis);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::SortChildren( HTREEITEM hItem)
{
   return TreeView_SortChildren( HWindow, hItem, 0);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::Expand( HTREEITEM hItem, UINT flags)
{
   return TreeView_Expand( HWindow, hItem, flags);
}

// ---------------------------------------------------------------------------

UINT TTreeView::GetIndent()
{
   return TreeView_GetIndent( HWindow);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::SetIndent( WPARAM indent)
{
   return TreeView_SetIndent( HWindow, indent);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::EnsureVisible( HTREEITEM hItem)
{
   return TreeView_EnsureVisible( HWindow, hItem);
}

// ---------------------------------------------------------------------------

UINT TTreeView::GetCount()
{
   return TreeView_GetCount( HWindow);
}

// ---------------------------------------------------------------------------

UINT TTreeView::GetVisibleCount()
{
   return TreeView_GetVisibleCount( HWindow);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetNextItem( HTREEITEM hItem, UINT flags)
{
   return TreeView_GetNextItem( HWindow, hItem, flags);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetChild( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_CHILD);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetDropHilite()
{
   return GetNextItem( NULL, TVGN_DROPHILITE);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetFirstVisible()
{
   return GetNextItem( NULL, TVGN_FIRSTVISIBLE);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetNextSibling( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_NEXT);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetNextVisible( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_NEXTVISIBLE);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetParent( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_PARENT);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetPrevSibling( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_PREVIOUS);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetPrevVisible( HTREEITEM hitem)
{
   return GetNextItem( hitem, TVGN_PREVIOUSVISIBLE);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetRoot()
{
   return GetNextItem( NULL, TVGN_ROOT);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::GetSelection()
{
   return GetNextItem( NULL, TVGN_CARET);
}

// ---------------------------------------------------------------------------

HIMAGELIST TTreeView::CreateDragImage( HTREEITEM hItem)
{
   return TreeView_CreateDragImage( HWindow, hItem);
}

// ---------------------------------------------------------------------------

HTREEITEM TTreeView::HitTest( LPTV_HITTESTINFO lpht)
{
   return TreeView_HitTest( HWindow, lpht);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::DeleteTreeViewItem( HTREEITEM hItem)
{
   return TreeView_DeleteItem( HWindow, hItem);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::DeleteAllItems()
{
   return TreeView_DeleteAllItems( HWindow);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::GetISearchString( LPSTR lpsz)
{
   return TreeView_GetISearchString( HWindow, lpsz);
}

// ---------------------------------------------------------------------------

BOOL TTreeView::GetItemRect( HTREEITEM hItem, RECT* rect, BOOL TextOnly)
{
   return TreeView_GetItemRect( HWindow, hItem, rect, TextOnly);
}

// ---------------------------------------------------------------------------


